#include "Gdl.h"
#include "carot.h"
#include "truche.h"
#include "truche2.h"
#include "truche3.h"
#include "tira.h"
#include "tir.h"
#include "tomata.h"
#include "poivron.h"
#include "prestart.h"
#include "title2.h"
#include "destru.h"
#include "palette.h"
#include "FONT8.h"


#define MAX_TIRE 20
#define MAX_ENE 5
#define MAX_POI 3

//switch define
#define GFX_TIRE 0
#define GFX_ENE 1
#define GFX_POI 2

char QUOI;
int score;

typedef struct
{
	int pos_x, pos_y;
	char speed;
	char active;

}SPRITE;

SPRITE tire_perso[MAX_TIRE];
SPRITE enemi[MAX_ENE];
SPRITE poivre[MAX_POI];


struct font font;
struct gfx con;
struct gfx mon_tire;
struct gfx tomate;
struct gfx poivro;
struct gfx prestar;

int x, y;
int posx1;
int posx2;
int posx3;
int posx4;
int posx5;
int posx6;
int xm, xn;
char animx;


void GpMain(void *arg);
void MainStart(void);
void MainIntro(void);
void Init_Gfx(void);
void Creer_GFX(int x, int y, char speed);
void Afficher_Bouger_Gfx(void);
void Action_Joueur(void);
void Action_temps(void);
void Collision(void);


void Collision_Poi(void);

void GpMain(void *arg)
{
	init_screen(8);
	set_pal(palette);
	MainStart();
}	

void MainStart(void)
{
	load_anim(&prestar,0,0,2,(unsigned char *)prestart,350,2,0,144,16,prestar.pos_x,prestar.pos_x,0xAE);
	prestar.pos_x=88;
	prestar.pos_y=190;
		
		for (;;)
		{
			flip_screen();
			refresh_key();
			GpBitBlt(NULL,&gpDraw[nflip],0, 0, 320, 240,(unsigned char*)title2,0, 0, 320, 240);	

			play_anim(&prestar,0,0);
			if (up_front(256)) MainIntro();
		}
}
	
void MainIntro(void)
{
	Init_Gfx();


	load_anim(&con,0,0,3,(unsigned char *)carot,200,2,0,60,40,con.pos_x,con.pos_y,0xAE);
	load_anim(&con,1,3,3,(unsigned char *)tira,75,2,0,60,40,con.pos_x,con.pos_y,0xAE);
	load_anim(&mon_tire,0,0,2,(unsigned char *)tir,100,2,0,12,8,mon_tire.pos_x,mon_tire.pos_y,0xAE);
	load_anim(&tomate,0,0,3,(unsigned char *)tomata,100,2,0,40,40,tomate.pos_x,tomate.pos_y,0xAE);
	load_anim(&tomate,1,3,4,(unsigned char *)destru,100,2,0,40,40,tomate.pos_x,tomate.pos_y,0xAE);
	load_anim(&poivro,0,0,3,(unsigned char *)poivron,100,2,0,40,40,poivro.pos_x,poivro.pos_y,0xAE);
	load_anim(&poivro,1,3,4,(unsigned char *)destru,100,2,0,40,40,poivro.pos_x,poivro.pos_y,0xAE);
	load_font(&font,(unsigned char *)FONT8,8,8,0xAE,95) ;

	xm=0*8;
	xn=320*8;

	posx1 = 0;
	posx2 = 320;
	posx3 = 0;
	posx4 = 320;
	posx5 = 0;
	posx6 = 320;
	animx = 0;
	score = 0;
	
	for (;;)
	{
		flip_screen();
		refresh_key();

		GpBitBlt(NULL,&gpDraw[nflip],posx1, 0, 320, 98,(unsigned char*)truche,0, 0, 320, 98);
		GpBitBlt(NULL,&gpDraw[nflip],posx2, 0, 320, 98,(unsigned char*)truche,0, 0, 320, 98);

		GpTransBlt(NULL,&gpDraw[nflip],posx3, 0, 320, 240,(unsigned char*)truche2,0, 0,320,240,0xAE);
		GpTransBlt(NULL,&gpDraw[nflip],posx4, 0, 320, 240,(unsigned char*)truche2,0, 0,320,240,0xAE);

		GpTransBlt(NULL,&gpDraw[nflip],posx5, 172, 320, 62,(unsigned char*)truche3,0, 0,320,62,0xAE);
		GpTransBlt(NULL,&gpDraw[nflip],posx6, 172, 320, 62,(unsigned char*)truche3,0, 0,320,62,0xAE);
		

		play_anim(&con,animx,0);
		draw_text(&font, "SCORE:",5 ,5);
		draw_int(&font, score, 61,5);
	
		xm-=4;
		xn-=4;

		posx1=xm>>3;
		posx2=xn>>3;
		posx3-=2;
		posx4-=2;
		posx5-=4;
		posx6-=4;
		
		
		
		if (xm==-320*8)xm=320*8;
		if (xn==-320*8)xn=320*8;
			
		if (posx1 == -320) posx1 = 320;
		if (posx2 == -320) posx2 = 320;
		if (posx3 == -320) posx3 = 320;
		if (posx4 == -320) posx4 = 320;
		if (posx5 == -320) posx5 = 320;
		if (posx6 == -320) posx6 = 320;

		
		if (up_front(512)) GpAppExit();
		if (up_front(256)) MainStart();

		if(key_pressed&1 && con.pos_x >0) con.pos_x-=5;
		if(key_pressed&4 && con.pos_x <260) con.pos_x+=5;

		if(key_pressed&8 && con.pos_y >0) con.pos_y-=5;
		if(key_pressed&2 && con.pos_y <200) con.pos_y+=5;

		if (con.animation[1].curent_frame == con.animation[1].frame_stop)
		{
			animx = 0;	
			con.animation[1].curent_frame = con.animation[1].frame_start;
		}
		
		Afficher_Bouger_Gfx();
		Action_Joueur();
		Action_temps();
		Collision();
	}
}


void Init_Gfx(void)
{
    char i,j,k;
        
	for(i=0; i<MAX_TIRE; i++)
	{
		tire_perso[i].pos_x = 0;
		tire_perso[i].pos_y = 0;
		tire_perso[i].speed = 0;
		tire_perso[i].active = 0;
	}
        
	for(j=0; j<MAX_ENE; j++)
	{        
		enemi[j].pos_x = 0;
		enemi[j].pos_y = 0;
		enemi[j].speed = 0;
		enemi[j].active = 0;
    } 
 
	for(k=0; k<MAX_POI; k++)
	{	
		poivre[k].pos_x = 0;
		poivre[k].pos_y = 0;
		poivre[k].speed = 0;
		poivre[k].active = 0;
	}      
        
}

	

void Creer_Gfx(char QUOI, int x, int y, char speed)
{
	char i,j,k;
        
	switch(QUOI)
	{
				case GFX_TIRE:
                        for(i=0; i<MAX_TIRE; i++)
                        {
                                if(tire_perso[i].active == 0)
                                {
                                        tire_perso[i].active = 1;
                                        tire_perso[i].pos_x = x;
                                        tire_perso[i].pos_y = y;
                                        tire_perso[i].speed = speed;
                                        break;
                                }
                        }
                        break;
                
                case GFX_ENE:
                        for(j=0; j<MAX_ENE; j++)
                        {                
                                if(enemi[j].active == 0)
                                {        
                                        enemi[j].active = 1;
                                        enemi[j].pos_x = x;
                                        enemi[j].pos_y = y;
                                        enemi[j].speed = speed;
                                        break;        
                                }
                        }
                        break;                

                case GFX_POI:
                        for(k=0; k<MAX_POI; k++)
                        {                
                                if(poivre[k].active == 0)
                                {        
                                        poivre[k].active = 1;
                                        poivre[k].pos_x = x;
                                        poivre[k].pos_y = y;
                                        poivre[k].speed = speed;
                                        break;
                                }
                        }
                        break;
        }                
}


void Afficher_Bouger_Gfx(void)
{
	char i,j,k;
	char animen1;
	char animen2;
	animen1=0;
	animen2=0;
	for(i=0; i<MAX_TIRE; i++)
	{
		if(tire_perso[i].active)
		{
			tire_perso[i].pos_x += tire_perso[i].speed;
			play_anim_xy(&mon_tire,0, tire_perso[i].pos_x, tire_perso[i].pos_y, 0);
		}
	}

	for(j=0; j<MAX_ENE; j++)
	{	
		if(enemi[j].active)
		{
			enemi[j].pos_x -= enemi[j].speed;
			play_anim_xy(&tomate,animen1, enemi[j].pos_x, enemi[j].pos_y, 0);
			if(enemi[j].pos_x<-40 || enemi[j].pos_y>240) enemi[j].active=0;
		}
	}

	for(k=0; k<MAX_POI; k++)
	{	
		if(poivre[k].active)
		{
			poivre[k].pos_x -= poivre[k].speed;
			play_anim_xy(&poivro,animen2, poivre[k].pos_x, poivre[k].pos_y, 0);
			if(poivre[k].pos_x<-40 || poivre[k].pos_y>240) poivre[k].active=0;
		}
	}
}



void Action_Joueur(void)
{
	con.perso_tire = 0;
	
	if (key_pressed&64)
	{
		animx=1;
		
		if ((GpTickCountGet()-con.tire_timer)>200)
		{
			con.perso_tire = 1;
			con.tire_timer = GpTickCountGet();
			
			Creer_Gfx(GFX_TIRE, con.pos_x+55, con.pos_y+18, 8);
		}
	}
}


void Action_temps(void)
{
	if ((GpTickCountGet()-tomate.ene_timer)>300)
	{
		Creer_Gfx(GFX_ENE, 360, 2+rand()%200 , 2+rand()%6);
	    tomate.ene_timer = GpTickCountGet();
	}
        
	if ((GpTickCountGet()-poivro.poi_timer)>100)
	{
		Creer_Gfx(GFX_POI, 360, 2+rand()%200 ,2+ rand()%6);
		poivro.poi_timer = GpTickCountGet();
	}
}

void Collision(void)
{
        char i,j,k;
        int timing;

        
        for(i=0;i<MAX_TIRE;i++)
        {
                if(tire_perso[i].active)
                {
                        if(tire_perso[i].pos_x<-20||tire_perso[i].pos_x>320) tire_perso[i].active=0;
                        
                        for(j=0;j<MAX_ENE;j++)
                        {
                               if(enemi[j].active)
                               {
                               		if( (tire_perso[i].pos_x > enemi[j].pos_x) && (tire_perso[i].pos_x+12 < enemi[j].pos_x+40)
                                        && (tire_perso[i].pos_y > enemi[j].pos_y) && (tire_perso[i].pos_y+8 < enemi[j].pos_y+40) )
                                 	{
						timing=+2;
                                		if (timing>10)
                                 		{
                                           		tire_perso[i].active=0; 
                                           		enemi[j].active=0;
                                           		score+=10;
                                        	}   
                                 	}

                                }
                        }
                
                        for(k=0;k<MAX_POI;k++)
                        {
                               if(poivre[k].active)
                               {
                               		if( (tire_perso[i].pos_x > poivre[k].pos_x) && (tire_perso[i].pos_x+12 < poivre[k].pos_x+40)
                                        && (tire_perso[i].pos_y > poivre[k].pos_y) && (tire_perso[i].pos_y+8 < poivre[k].pos_y+40) )
                                 	{
                                           tire_perso[i].active=0; 
                                           poivre[k].active=0;
                                           score+=30;
                                          
                                 	}
                                }
                        }
                }
        }
}

